=== debian/changelog ===
ceph (18.2.1+ds-1deepin1+rb1) unstable; urgency=medium

  * Fix build with fmtlib-10.
    Apply patch from https://github.com/ceph/ceph/pull/53698

 -- Tianyu Chen <sweetyfish@deepin.org>  Wed, 13 Mar 2024 12:08:36 +0800

ceph (18.2.1+ds-1) unstable; urgency=medium

  * Uploading to unstable.
  * New upstream release:
    - Fixes FTBFS (Closes: #1058543, #1056085).
  * Add pybind-rbd-make-cdef-functions-not-propagate-excepti.patch from
    upstream master branch to fix FTBFS of rbd.pyx with Cython 3.0.
    (Closes: #1056793).
  * Manually install systemd services in each package.

 -- Thomas Goirand <zigo@debian.org>  Mon, 19 Feb 2024 08:55:30 +0100
